IMPLEMENTATION MODULE PlainCls;

FROM SYSTEM IMPORT ADR, ADDRESS ;
FROM Windows IMPORT 
     HANDLE, HWND, WNDCLASS, NULL, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,
     CS_VREDRAW, CS_HREDRAW, IDC_CROSS, WHITE_BRUSH,
     CreateWindow, RegisterClass, LoadCursor, GetStockObject;                       
     
IMPORT MainWnd;

(*---------------------------------------------------------*)

PROCEDURE Init( AppName    : ARRAY OF CHAR;
                NumActions : CARDINAL;
                Instance, PrevInstance : HANDLE ) : HWND ;
   BEGIN
      RETURN MainWnd.Init( AppName, NumActions, 
                           Register, Create,
                           Instance, PrevInstance ) ;
   END Init;
   
(*---------------------------------------------------------*)

PROCEDURE Create( AppName  : ARRAY OF CHAR;
                  Instance : HANDLE ) : HWND [LONG];
   BEGIN
      RETURN CreateWindow( ADR('Plain'), ADR(AppName), 
                           WS_OVERLAPPEDWINDOW,
                           CW_USEDEFAULT, 0, CW_USEDEFAULT, 0,
                           NULL, NULL,
                           Instance,
                           ADDRESS(0)) ;
   END Create;

(*---------------------------------------------------------*)

PROCEDURE Register( Instance : HANDLE ) : CARDINAL [LONG];
 
   VAR Class : WNDCLASS ;

   BEGIN
       WITH Class DO
            style := CS_VREDRAW + CS_HREDRAW ;
            lpfnWndProc := MainWnd.WindowProc ;
            cbClsExtra := 0 ;
            cbWndExtra := 0 ;
            hInstance := Instance;
            hIcon := 0 ;
            hCursor := LoadCursor ( NULL, IDC_CROSS ) ;
            hbrBackground := GetStockObject( WHITE_BRUSH ) ;
            lpszMenuName := NIL ;
            lpszClassName := ADR('Plain');
       END;
       RETURN RegisterClass(Class) ;
   END Register;

END PlainCls.
